function [x,fx]=linmin(func,x,d,toler,maxit);

 
    xl=x-abs(d);
    xh=x+abs(d);
        
    fx=func(x);
    fxl=func(xl);
    fxh=func(xh);
    
    iter=0;
    while ((abs(xh-xl)>toler)&&(iter<maxit)&&(fx>min([fx;fxl;fxh])))
        if (fxl>fxh)
            xt=x;
            fxt=fx;
            x=(x+xh)/2;
            fx=func(x);
            xl=xt;
            fxl=fxt;
        else
            xt=x;
            fxt=fx;
            x=(x+xl)/2;
            fx=func(x);
            xh=xt;
            fxh=fxt;
        end
    end



    
% Here we alsways drop the point farthest away
    
    iter=0;
    while ((abs(xh-xl)>toler)&(iter<maxit))        
%         [xl x xh]
        iter=iter+1;
        if (abs(xh-x)>abs(x-xl))
            xnew=(x+xh)/2;
            fxnew=func(xnew);
            if (fxnew<fx)
                xl=x;
                fxl=fx;
                x=xnew;
                fx=fxnew;
            else
                xh=xnew;
                fxh=fxnew;
            end
        else
            xnew=(x+xl)/2;
            fxnew=func(xnew);
            if (fxnew<fx)
                xh=x;
                fxh=fx;
                x=xnew;
                fx=fxnew;
            else
                xl=xnew;
                fxl=fxnew;
            end
        end
    end
    if (fx>fxh)
        fx=fxh;
        x=xh;
    end
    if (fx>fxl)
        fx=fxl;
        x=xl;
    end
    fprintf('        Function Value after Linmin %9.5f',fx);
    fprintf(' \n');
end
