% The function takes z, alpha, gamma and tau as input arguments and
% calculates Zinv


function [t] = ZinvT2Jumps(z, alpha, gamma, tau)

    tmax=z.^(1./alpha);
    ii=(tmax>tau(:,1));
    tmin=tau(:,1).*ii+tmax.*(1-ii);

    
    toler=1.0d-5;
    maxdif=max(abs(tmax-tmin));
    iter=0;
    while ((maxdif>toler)&&(iter<200))
        iter=iter+1;
        if (iter>190)
            'ZinvT2Jumps'
            [iter maxdif]
        end
        tmid=(tmax+tmin)/2;
        zmid=ZiT2Jumps(tmid, alpha, gamma, tau);
        ii=(zmid>z);
        if (iter>190)
            'ZinvT2Jumps iter>190'
            [iter maxdif]
            save('debugdata','tmax', 'tmin', 'tmid','z','zmid','ii');
            stop
        end
        tmin=tmin.*ii+tmid.*(1-ii);
        tmax=tmid.*ii+tmax.*(1-ii);
        maxdif=2*max(abs(tmax-tmin)./(abs(tmax)+abs(tmin)));
    end
    t=(tmax+tmin)/2;
 
end