% Return derivative of utility at t
% Input values: t, k, th, x, rho
% ert = exp(-rho .* tt)
% Return: out: derivative of utility at t

% example: out = indfoc(t, k, th, x, ert)

function [out] = indfocT2Jumps(t, k, th, fi, ert, tau)
out = k .* ert - fi .* ZiT2Jumps(t, th(2), th(3:4), tau) .* ert;
end
