function [f, der] = ol_psmle_obj_foc(beta, y, x)
if (isvector(x))
    n = length(x);
else
    n = size(x, 1);
end
d0 = y > 0;
d1 = y > 1;
x0 = [x zeros(n, 1)];
x1 = [x (zeros(n, 1) + 1)];
xb0 = x0 * beta;
xb1 = x1 * beta;

f = dot(xb0, d0) + dot(xb1, d1) - sum(log(1 + exp(xb0))) - sum(log(1 + exp(xb1)));
f = -f / n;

% df = transpose(zeros(n, 1) + 1) * (bsxfun(@times, d0 - Lambda(xb0), x0) + ...
%     bsxfun(@times, d1 - Lambda(xb1), x1));


df=sum(repmat((d0-Lambda(xb0)),1,size(x0,2)).*x0+repmat((d1-Lambda(xb1)),1,size(x1,2)).*x1);

der =  - df / n;
end