function V=calc_var_matrix2Jumps(W,xx0,xx1,xOne,xUnion,censotim0,censotim1,Aage62_0,Aage62_1,Aage65_0,Aage65_1, beta_aux, RHO, t_point_scale, th,cop,nreps,del,nrep_multiplier)
	
    if (cop==1)
        k=(length(th)-8)/2;	
    else  
        'only implemented with copula'
        stop
        k = (length(th)-3)/2;		
    end
    n=size(xx0,1)/nreps;
    
    seeed = 97171;
    rng(seeed);
    K=rand(n*nreps*nrep_multiplier,2);
    
    xx0=repmat(xx0,nrep_multiplier,1);
    xx1=repmat(xx1,nrep_multiplier,1);
    xOne=repmat(xOne,nrep_multiplier,1);
    xUnion=repmat(xUnion,nrep_multiplier,1);
    censotim0=repmat(censotim0,nrep_multiplier,1);
    censotim1=repmat(censotim1,nrep_multiplier,1);
    Aage62_0=repmat(Aage62_0,nrep_multiplier,1);
    Aage62_1=repmat(Aage62_1,nrep_multiplier,1);
    Aage65_0=repmat(Aage65_0,nrep_multiplier,1);
    Aage65_1=repmat(Aage65_1,nrep_multiplier,1);


	sco_o = HdP_scores2Jumps(th, xx0,xx1, xOne, xUnion, censotim0,censotim1,Aage62_0,Aage62_1,Aage65_0,Aage65_1, beta_aux, cop , RHO, t_point_scale,  K);
	theta_natural = from_reparameterized2Jumps(th, cop);

	H =zeros(length(th), length(beta_aux))	;					 
	
    fprintf('\n')
	for i=1:length(th)
        fprintf('Calculating H row %4.0f\n',i)
		theta_p=theta_natural;
        theta_n=theta_natural;
		theta_p(i)=theta_natural(i)+del;					 
		theta_n(i)=theta_natural(i)-del;							 
		
        theta_p=to_reparameterized2Jumps(theta_p,cop);
		sco_p = HdP_scores2Jumps(theta_p, xx0,xx1, xOne, xUnion, censotim0,censotim1,Aage62_0,Aage62_1,Aage65_0,Aage65_1, beta_aux, cop , RHO, t_point_scale,  K);	
        
		problem_der=0;
        problem_der=(theta_n(1)<=1+del)*(i==1)+(theta_n(2)<=del)*(i==2)+(theta_n(3)<=del)*(i==3)+(theta_n(4)<=del)*(i==4)+ ...
                                   (theta_n(k+5)<=del)*(i==k+5)+(theta_n(k+6)<=del)*(i==k+6)+(theta_n(k+7)<=del)*(i==k+7);
        if (cop==1)
            problem_der=problem_der+(theta_n(length(theta_n))<=del)*(i==length(theta_n));
        end
        
        if (problem_der>0)
            H(i,:)=(sco_p-sco_o)'/del;
            'problem_der'
            i
        else
            theta_n=to_reparameterized2Jumps(theta_n,cop);
            sco_n = HdP_scores2Jumps(theta_n, xx0,xx1, xOne, xUnion, censotim0,censotim1,Aage62_0,Aage62_1,Aage65_0,Aage65_1, beta_aux, cop , RHO, t_point_scale,  K);
            H(i,:)=(sco_p-sco_n)'/(2*del);
        end
	end
    V = H *W*H';
	V = (1 + 1/nreps)*inv(V)/n;
end
