function derder = ol_psmle_soc(beta, x)
if (isvector(x))
    n = length(x);
else
    n = size(x, 1);
end
x0 = [x zeros(n, 1)];
x1 = [x (zeros(n, 1) + 1)];
xb0 = x0 * beta;
xb1 = x1 * beta;

derder = (transpose(bsxfun(@times, (1 - Lambda(xb0)) .* Lambda(xb0), x0)) * x0 + ...
    transpose(bsxfun(@times, (1 - Lambda(xb1)) .* Lambda(xb1), x1)) * x1)/n;
end
